#include "StdAfx.h"
#include "DialogProc.h"
#include "resource.h"

#include "ConsoleCloseUtils.h"

static HFONT hFixedFont;
extern HINSTANCE g_hInstance;

// oߕ\_CAÕvV[W
BOOL CALLBACK ProgressDialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		if (g_StdOut.SetWindow(::GetDlgItem(hDlg, IDE_OUTPUT)))
		{
			hFixedFont = NULL;
			char lpBuffer[80];
			switch (lParam)
			{
			case 'a':
			case 'A':
				::LoadString(g_hInstance, IDS_PROGRESS_COMPRESS, lpBuffer, 64);
				break;
			case 'e':
			case 'E':
			case 'x':
			case 'X':
				::LoadString(g_hInstance, IDS_PROGRESS_EXTRACT, lpBuffer, 64);
				break;
			case 'd':
			case 'D':
				::LoadString(g_hInstance, IDS_PROGRESS_DELETE, lpBuffer, 64);
				break;
			case 'u':
			case 'U':
				::LoadString(g_hInstance, IDS_PROGRESS_UPDATE, lpBuffer, 64);
				break;
			default:
				::ResumeThread(g_StdOut.m_hThread);
				return FALSE;
			}
			::SetWindowText(hDlg, lpBuffer);

			// _CAÕTCY
			::FillMemory(lpBuffer, 80, '-');
			LOGFONT lf;
			SIZE size;
			RECT rc;
			HWND hWnd = ::GetDlgItem(hDlg, IDE_OUTPUT);
			::GetObject((HGDIOBJ)::SendMessage(hWnd, WM_GETFONT, 0, 0), sizeof(LOGFONT), &lf);
			::LoadString(g_hInstance, IDS_PROGRESS_FONT_FACE, lf.lfFaceName, LF_FACESIZE);
			hFixedFont = ::CreateFontIndirect(&lf);
			::SendMessage(hWnd, WM_SETFONT, (WPARAM)hFixedFont, TRUE);
			HDC hDC = ::GetDC(hWnd);
			HGDIOBJ hObj = ::SelectObject(hDC, hFixedFont);
			::GetTextExtentPoint32(hDC, lpBuffer, 74, &size);
			::SelectObject(hDC, hObj);
			::ReleaseDC(hWnd, hDC);
			int nWidth = ::GetSystemMetrics(SM_CXVSCROLL) + size.cx + 6;
			::GetWindowRect(hWnd, &rc);
			::SetWindowPos(hWnd, NULL, 0, 0, nWidth, rc.bottom -rc.top, SWP_NOMOVE);
			nWidth -= rc.right - rc.left;
			::GetWindowRect(hDlg, &rc);
			::MoveWindow(hDlg, rc.left, rc.top, rc.right - rc.left + nWidth, rc.bottom - rc.top, FALSE);
			hWnd = ::GetDlgItem(hDlg, IDCANCEL);
			::GetWindowRect(hWnd, &rc);
			POINT point;
			point.x = rc.left;
			point.y = rc.top;
			::ScreenToClient(hDlg, &point);
			::SetWindowPos(hWnd, NULL, point.x + nWidth, point.y, 0, 0, SWP_NOSIZE);
			::MoveOwnerCenter(hDlg);
			hWnd = ::GetWindow(hDlg, GW_OWNER);
			if (hWnd)
				::EnableWindow(hWnd, FALSE);
			::ShowWindow(hDlg, SW_SHOW);
			::ResumeThread(g_StdOut.m_hThread);
			return FALSE;
		}
		else
		{
			g_StdOut.StopProgress();
			::ResumeThread(g_StdOut.m_hThread);
		}
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
		case IDCANCEL:
			::PostMessage(hDlg, WM_CLOSE, 0, 0);
			return TRUE;
		default:
			return FALSE;
		}
	case WM_OUTPUT_PROGRESS:
		{
			HWND hOutWnd = ::GetDlgItem(hDlg, IDE_OUTPUT);
			int nBack = (int)wParam;
			int nPos = ::GetWindowTextLength(hOutWnd);
			if (nPos - nBack < 0)
				nPos = nBack;
			if (::GetFocus() == hOutWnd)
			{
				::mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
				::SetFocus(::GetDlgItem(hDlg, IDCANCEL));
			}
			::SendMessage(hOutWnd, EM_SETSEL, nPos - nBack, nPos);
			::SendMessage(hOutWnd, EM_REPLACESEL, FALSE, lParam);
			break;
		}
	case WM_CLOSE:
		if (!g_StdOut.IsStop())
		{
			g_StdOut.StopProgress();
			NConsoleClose::HandlerRoutine(CTRL_C_EVENT);
			break;
		}
		if (hFixedFont)
		{
			HWND hOwnerWnd = ::GetWindow(hDlg, GW_OWNER);
			if (hOwnerWnd)
				::EnableWindow(hOwnerWnd, TRUE);
			::DeleteObject((HGDIOBJ)hFixedFont);
		}
		::DestroyWindow(hDlg);
		::PostQuitMessage(0);
		break;
	default:
		return FALSE;
	}
	return TRUE;
}


// ݒp_CAÕvV[W
BOOL CALLBACK ConfigDialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			::MoveOwnerCenter(hDlg);
			char lpVersion[64];
			sprintf(lpVersion, "7-zip32.dll version %d.%.2d.%.2d.%.2d", ::SevenZipGetVersion() / 100, ::SevenZipGetVersion() % 100, ::SevenZipGetSubVersion() / 100, ::SevenZipGetSubVersion() % 100);
			::SetWindowText(::GetDlgItem(hDlg, IDS_VERSION), lpVersion);
		}
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
			::EndDialog(hDlg, TRUE);
		case IDCANCEL:
			::EndDialog(hDlg, FALSE);
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}
	return TRUE;
}

// pX[h̓_CAÕvV[W
BOOL CALLBACK PasswordDialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			LPCTSTR* lpsz = (LPCTSTR*)lParam;
			::SetWindowText(hDlg, *lpsz);
			*lpsz = NULL;

			// nꂽ|C^ۑ
			::SetWindowLong(hDlg, GWL_USERDATA, lParam);

			// EBhEeEBhE̒SɈړ
			::MoveOwnerCenter(hDlg);
			break;
		}
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_MASK:
			{
				// pX[h̃}XNON/OFF
				HWND hPassWnd = ::GetDlgItem(hDlg, IDE_PASSWORD);
				if (::SendMessage((HWND)lParam, BM_GETCHECK, 0, 0) == BST_CHECKED)
					::SendMessage(hPassWnd, EM_SETPASSWORDCHAR, 0, 0);
				else
					::SendMessage(hPassWnd, EM_SETPASSWORDCHAR, (WPARAM)'*', 0);
				::InvalidateRect(hPassWnd, NULL, TRUE);
				break;
			}
		case IDOK:
			{
				// nꂽ|C^Ƀobt@mۂpX[hi[
				LPSTR* lpPassword = (LPSTR*)::GetWindowLong(hDlg, GWL_USERDATA);
				int nLen = ::GetWindowTextLength(::GetDlgItem(hDlg, IDE_PASSWORD));
				if (nLen)
				{
					*lpPassword = (LPSTR)::GlobalAlloc(GMEM_FIXED, nLen + 1);
					::GetDlgItemText(hDlg, IDE_PASSWORD, *lpPassword, nLen + 1);
				}
				::EndDialog(hDlg, IDOK);
				break;
			}
		case IDCANCEL:
			::EndDialog(hDlg, IDCANCEL);
			break;
		default:
			return FALSE;
		}
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

// ㏑mF_CAÕvV[W
BOOL CALLBACK ConfirmationDialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			// ACR̃[h
			HINSTANCE hInst = ::LoadLibrary("SHELL32.DLL");
			if (hInst)
			{
				HICON hIcon = ::LoadIcon(hInst, MAKEINTRESOURCE(145));
				::SendMessage(::GetDlgItem(hDlg, IDS_REPLACE), STM_SETICON, (WPARAM)hIcon, 0);
				::FreeLibrary(hInst);
			}

			// t@C̐ݒ
			char lpFormat[64];
			char lpFileInfo[1024];
			char lpTime[32];
			FILETIME ftLocal;
			SYSTEMTIME stWrite;
			SHFILEINFO shellFileInfo;
			REPLACEFILEINFO* lpRfi = (REPLACEFILEINFO*)lParam;
			::GetDlgItemText(hDlg, IDS_OLD_FILE_INFO, lpFormat, 64);
			::FileTimeToLocalFileTime(&lpRfi->OldTime, &ftLocal);
			::FileTimeToSystemTime(&ftLocal, &stWrite);
			::wsprintf(lpTime, "%.4d/%.2d/%.2d %.2d:%.2d:%.2d", stWrite.wYear, stWrite.wMonth, stWrite.wDay, stWrite.wHour, stWrite.wMinute, stWrite.wSecond);
			::wsprintf(lpFileInfo, lpFormat, (const char*)lpRfi->OldName, lpTime, lpRfi->OldSize);
			::SetDlgItemText(hDlg, IDS_OLD_FILE_INFO, lpFileInfo);
			if (::SHGetFileInfo(lpRfi->OldName, FILE_ATTRIBUTE_NORMAL, &shellFileInfo, sizeof(shellFileInfo), SHGFI_ICON | SHGFI_USEFILEATTRIBUTES | SHGFI_LARGEICON)) 
				::SendMessage(::GetDlgItem(hDlg, IDS_OLD_ICON), STM_SETICON, (WPARAM)shellFileInfo.hIcon, 0);
			::GetDlgItemText(hDlg, IDS_NEW_FILE_INFO, lpFormat, 64);
			::FileTimeToLocalFileTime(&lpRfi->NewTime, &ftLocal);
			::FileTimeToSystemTime(&ftLocal, &stWrite);
			::wsprintf(lpTime, "%.4d/%.2d/%.2d %.2d:%.2d:%.2d", stWrite.wYear, stWrite.wMonth, stWrite.wDay, stWrite.wHour, stWrite.wMinute, stWrite.wSecond);
			::wsprintf(lpFileInfo, lpFormat, (const char*)lpRfi->NewName, lpTime, lpRfi->NewSize);
			::SetDlgItemText(hDlg, IDS_NEW_FILE_INFO, lpFileInfo);
			if (::SHGetFileInfo(lpRfi->NewName, FILE_ATTRIBUTE_NORMAL, &shellFileInfo, sizeof(shellFileInfo), SHGFI_ICON | SHGFI_USEFILEATTRIBUTES | SHGFI_LARGEICON)) 
				::SendMessage(::GetDlgItem(hDlg, IDS_NEW_ICON), STM_SETICON, (WPARAM)shellFileInfo.hIcon, 0);

			// EBhEeEBhE̒SɈړ
			::MoveOwnerCenter(hDlg);
			break;
		}
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDB_YES:
		case IDB_NO:
		case IDB_YES_ALL:
		case IDB_NO_ALL:
		case IDB_AUTO_RENAME:
		case IDCANCEL:
			::EndDialog(hDlg, (int)LOWORD(wParam));
			break;
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}
	return TRUE;
}